// pnPlugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "stdio.h"
#include "resource.h"
#include "pnPlugin.h"

static int selectedMode = 0;

plInfo Info = 
	{"0.3.0",
	"position",
	"inversion partielle",
	"dmo de plugin avec interaction par rglage de paramtre"
	};



BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


PNPLUGIN_API const char* PnPluginAppName( void )
{
    //version;
    const char * appName;
    appName = "PortaNum";
    return appName;
}

PNPLUGIN_API int PnPluginInfo(plInfo * pInfo )
{
	if (pInfo) 
	{*pInfo = Info;
    return 0;
	}
	else return 1;
}

BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT message,WPARAM wParam,LPARAM lParam)
{
	int radioSel;
	switch (message)
	{
	case WM_INITDIALOG :
		if (selectedMode == 0) radioSel = IDC_RADIO1;
		    else radioSel = IDC_RADIO2;
		CheckRadioButton(hDlg, IDC_RADIO1, IDC_RADIO2, radioSel);
		return true;
	case WM_COMMAND:
		switch (LOWORD (wParam))
			{
			case IDC_RADIO1:
				selectedMode = 0;
			break;
			case IDC_RADIO2:
				selectedMode = 1;
			break;
			case IDOK:
			case IDCANCEL:
				EndDialog(hDlg,0);
				return true;
			}
			break;
		}
		return FALSE;
}

PNPLUGIN_API IppStatus PnPluginDialog(HINSTANCE hInstance, HWND hwnd)
{	char buffer[128];
	LPSTR lpstrPrompt = &buffer[0];
	int res = DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),hwnd, AboutDlgProc);
	if (res == -1 ) { 
		sprintf(lpstrPrompt,"erreur : %d",GetLastError());
		MessageBox(NULL,lpstrPrompt,"",NULL);
		return 1; // pas de page de config
	}
	return 0; // ok
}


PNPLUGIN_API IppStatus PnPluginFunction( Ipp8u* pSrc, int srcStep, Ipp8u* pDst, int dstStep, IppiSize roiSize, int mode, int coef )
{
    IppStatus status = 0;  // 0 = no error
	Ipp8u * pS = pSrc;
	Ipp8u * pD = pDst;
	int w, iy, ix;

	int local_mode;

	// function implementation ...
	if (mode >1) mode = 0;
	if (mode < 0) local_mode = selectedMode;
		else local_mode = mode;

	switch (local_mode) {
	case 0 :
		w = (int) (roiSize.width * 3 * coef / 100.0);
		for (iy=0; iy<roiSize.height; iy++)
        {  for (ix=0; ix<(roiSize.width * 3); ix++) 
                {
                if (ix < w) pD[ix] = (Ipp8u) 255 - pS[ix];
				else pD[ix] = (Ipp8u) pS[ix];
                }
        pS=pS+srcStep;
		pD=pD+srcStep;
        }
	break;
	case 1 :
		w = (int) (roiSize.height * coef / 100.0);
		for (iy=0; iy<w; iy++)
        {  for (ix=0; ix<(roiSize.width * 3); ix++) 
                {
                pD[ix] = (Ipp8u) 255 - pS[ix];
                }
        pS=pS+srcStep;
		pD=pD+srcStep;
        }
		for (iy=w; iy<roiSize.height; iy++)
        {  for (ix=0; ix<(roiSize.width * 3); ix++) 
                {
                pD[ix] = (Ipp8u) pS[ix];
                }
        pS=pS+srcStep;
		pD=pD+srcStep;
        }
	break;
	default:
	break;
				}


    return status;
}

